--- old/usr/src/pkg/manifests/SUNWcs.mf	2016-06-02 19:51:17.994348957 -0400
+++ new/usr/src/pkg/manifests/SUNWcs.mf	2016-06-02 19:51:18.023517754 -0400
@@ -552,6 +552,7 @@
 file path=lib/svc/manifest/system/manifest-import.xml group=sys mode=0444
 file path=lib/svc/manifest/system/name-service-cache.xml group=sys mode=0444
 file path=lib/svc/manifest/system/pfexecd.xml group=sys mode=0444
+file path=lib/svc/manifest/system/process-security.xml group=sys mode=0444
 file path=lib/svc/manifest/system/rbac.xml group=sys mode=0444
 file path=lib/svc/manifest/system/rmtmpfiles.xml group=sys mode=0444
 file path=lib/svc/manifest/system/sac.xml group=sys mode=0444
@@ -1084,6 +1085,7 @@
 file path=usr/lib/help/auths/locale/C/SmfValueNADD.html
 file path=usr/lib/help/auths/locale/C/SmfValueNDMP.html
 file path=usr/lib/help/auths/locale/C/SmfValueNWAM.html
+file path=usr/lib/help/auths/locale/C/SmfValueProcSec.html
 file path=usr/lib/help/auths/locale/C/SmfValueRouting.html
 file path=usr/lib/help/auths/locale/C/SmfValueSMB.html
 file path=usr/lib/help/auths/locale/C/SmfValueVscan.html
--- old/usr/src/pkg/manifests/consolidation-osnet-osnet-message-files.mf	2016-06-02 19:51:19.071238193 -0400
+++ new/usr/src/pkg/manifests/consolidation-osnet-osnet-message-files.mf	2016-06-02 19:51:19.098862780 -0400
@@ -173,6 +173,7 @@
 file path=usr/lib/help/auths/locale/SmfValueNADD.html
 file path=usr/lib/help/auths/locale/SmfValueNDMP.html
 file path=usr/lib/help/auths/locale/SmfValueNWAM.html
+file path=usr/lib/help/auths/locale/SmfValueProcSec.html
 file path=usr/lib/help/auths/locale/SmfValueRouting.html
 file path=usr/lib/help/auths/locale/SmfValueSMB.html
 file path=usr/lib/help/auths/locale/SmfValueVscan.html
--- old/usr/src/pkg/manifests/system-extended-system-utilities.mf	2016-06-02 19:51:19.903124220 -0400
+++ new/usr/src/pkg/manifests/system-extended-system-utilities.mf	2016-06-02 19:51:19.930911467 -0400
@@ -62,6 +62,7 @@
 $(i386_ONLY)file path=usr/bin/$(ARCH32)/ppriv mode=0555
 $(i386_ONLY)file path=usr/bin/$(ARCH32)/preap mode=0555
 $(i386_ONLY)file path=usr/bin/$(ARCH32)/prun mode=0555
+$(i386_ONLY)file path=usr/bin/$(ARCH32)/psecflags mode=0555
 $(i386_ONLY)file path=usr/bin/$(ARCH32)/psig mode=0555
 $(i386_ONLY)file path=usr/bin/$(ARCH32)/pstack mode=0555
 $(i386_ONLY)file path=usr/bin/$(ARCH32)/pstop mode=0555
@@ -82,6 +83,7 @@
 file path=usr/bin/$(ARCH64)/ppriv mode=0555
 file path=usr/bin/$(ARCH64)/preap mode=0555
 file path=usr/bin/$(ARCH64)/prun mode=0555
+file path=usr/bin/$(ARCH64)/psecflags mode=0555
 file path=usr/bin/$(ARCH64)/psig mode=0555
 file path=usr/bin/$(ARCH64)/pstack mode=0555
 file path=usr/bin/$(ARCH64)/pstop mode=0555
@@ -195,6 +197,7 @@
 file path=usr/share/man/man1/ppgsz.1
 file path=usr/share/man/man1/ppriv.1
 file path=usr/share/man/man1/preap.1
+file path=usr/share/man/man1/psecflags.1
 file path=usr/share/man/man1/ptree.1
 file path=usr/share/man/man1/sdiff.1
 file path=usr/share/man/man1/sort.1
@@ -227,6 +230,7 @@
 hardlink path=usr/bin/ppriv target=../../usr/lib/isaexec
 hardlink path=usr/bin/preap target=../../usr/lib/isaexec
 hardlink path=usr/bin/prun target=../../usr/lib/isaexec
+hardlink path=usr/bin/psecflags target=../../usr/lib/isaexec
 hardlink path=usr/bin/psig target=../../usr/lib/isaexec
 hardlink path=usr/bin/pstack target=../../usr/lib/isaexec
 hardlink path=usr/bin/pstop target=../../usr/lib/isaexec
--- old/usr/src/pkg/manifests/system-header.mf	2016-06-02 19:51:20.721166162 -0400
+++ new/usr/src/pkg/manifests/system-header.mf	2016-06-02 19:51:20.749312487 -0400
@@ -1415,6 +1415,7 @@
 file path=usr/include/sys/scsi/targets/smp.h
 $(sparc_ONLY)file path=usr/include/sys/scsi/targets/ssddef.h
 file path=usr/include/sys/scsi/targets/stdef.h
+file path=usr/include/sys/secflags.h
 $(i386_ONLY)file path=usr/include/sys/segment.h
 $(i386_ONLY)file path=usr/include/sys/segments.h
 file path=usr/include/sys/select.h
--- old/usr/src/pkg/manifests/system-test-ostest.mf	2016-06-02 19:51:21.813408727 -0400
+++ new/usr/src/pkg/manifests/system-test-ostest.mf	2016-06-02 19:51:21.841105461 -0400
@@ -24,6 +24,7 @@
 dir path=opt/os-tests/bin
 dir path=opt/os-tests/runfiles
 dir path=opt/os-tests/tests
+dir path=opt/os-tests/tests/secflags
 dir path=opt/os-tests/tests/sigqueue
 file path=opt/os-tests/README mode=0444
 file path=opt/os-tests/bin/ostest mode=0555
@@ -31,6 +32,21 @@
 file path=opt/os-tests/runfiles/omnios.run mode=0444
 file path=opt/os-tests/runfiles/openindiana.run mode=0444
 file path=opt/os-tests/tests/poll_test mode=0555
+file path=opt/os-tests/tests/secflags/addrs-32 mode=0555
+file path=opt/os-tests/tests/secflags/addrs-64 mode=0555
+file path=opt/os-tests/tests/secflags/secflags_aslr mode=0555
+file path=opt/os-tests/tests/secflags/secflags_core mode=0555
+file path=opt/os-tests/tests/secflags/secflags_dts mode=0555
+file path=opt/os-tests/tests/secflags/secflags_elfdump mode=0555
+file path=opt/os-tests/tests/secflags/secflags_forbidnullmap mode=0555
+file path=opt/os-tests/tests/secflags/secflags_limits mode=0555
+file path=opt/os-tests/tests/secflags/secflags_noexecstack mode=0555
+file path=opt/os-tests/tests/secflags/secflags_proc mode=0555
+file path=opt/os-tests/tests/secflags/secflags_psecflags mode=0555
+file path=opt/os-tests/tests/secflags/secflags_syscall mode=0555
+file path=opt/os-tests/tests/secflags/secflags_truss mode=0555
+file path=opt/os-tests/tests/secflags/secflags_zonecfg mode=0555
+file path=opt/os-tests/tests/secflags/stacky mode=0555
 file path=opt/os-tests/tests/sigqueue/sigqueue_queue_size mode=0555
 file path=opt/os-tests/tests/spoof-ras mode=0555
 license cr_Sun license=cr_Sun
--- old/usr/src/test/os-tests/runfiles/delphix.run	2016-06-02 19:51:22.617740861 -0400
+++ new/usr/src/test/os-tests/runfiles/delphix.run	2016-06-02 19:51:22.653320137 -0400
@@ -24,5 +24,20 @@
 [/opt/os-tests/tests/poll_test]
 user = root
 
+[/opt/os-tests/tests/secflags]
+user = root
+tests = ['secflags_aslr',
+         'secflags_core',
+         'secflags_dts',
+         'secflags_elfdump',
+         'secflags_forbidnullmap',
+         'secflags_limits,
+         'secflags_noexecstack',
+         'secflags_proc',
+         'secflags_psecflags',
+         'secflags_syscall',
+         'secflags_truss,'
+         'secflags_zonecfg']
+
 [/opt/os-tests/tests/sigqueue]
 tests = ['sigqueue_queue_size']
--- old/usr/src/test/os-tests/runfiles/omnios.run	2016-06-02 19:51:23.408686325 -0400
+++ new/usr/src/test/os-tests/runfiles/omnios.run	2016-06-02 19:51:23.436045067 -0400
@@ -24,5 +24,20 @@
 [/opt/os-tests/tests/poll_test]
 user = root
 
+[/opt/os-tests/tests/secflags]
+user = root
+tests = ['secflags_aslr',
+         'secflags_core',
+         'secflags_dts',
+         'secflags_elfdump',
+         'secflags_forbidnullmap',
+         'secflags_limits,
+         'secflags_noexecstack',
+         'secflags_proc',
+         'secflags_psecflags',
+         'secflags_syscall',
+         'secflags_truss',
+         'secflags_zonecfg']
+
 [/opt/os-tests/tests/sigqueue]
 tests = ['sigqueue_queue_size']
--- old/usr/src/test/os-tests/runfiles/openindiana.run	2016-06-02 19:51:24.190586929 -0400
+++ new/usr/src/test/os-tests/runfiles/openindiana.run	2016-06-02 19:51:24.218496333 -0400
@@ -24,5 +24,20 @@
 [/opt/os-tests/tests/poll_test]
 user = root
 
+[/opt/os-tests/tests/secflags]
+user = root
+tests = ['secflags_aslr',
+         'secflags_core',
+         'secflags_dts',
+         'secflags_elfdump',
+         'secflags_forbidnullmap',
+         'secflags_limits',
+         'secflags_noexecstack',
+         'secflags_proc',
+         'secflags_psecflags',
+         'secflags_syscall',
+         'secflags_truss',
+         'secflags_zonecfg']
+
 [/opt/os-tests/tests/sigqueue]
 tests = ['sigqueue_queue_size']
--- old/usr/src/test/os-tests/tests/Makefile	2016-06-02 19:51:24.980818672 -0400
+++ new/usr/src/test/os-tests/tests/Makefile	2016-06-02 19:51:25.009026980 -0400
@@ -13,6 +13,6 @@
 # Copyright (c) 2012 by Delphix. All rights reserved.
 #
 
-SUBDIRS = poll sigqueue spoof-ras
+SUBDIRS = poll secflags sigqueue spoof-ras
 
 include $(SRC)/test/Makefile.com
--- /dev/null	2016-06-02 19:51:25.000000000 -0400
+++ new/usr/src/test/os-tests/tests/secflags/Makefile	2016-06-02 19:51:25.780675721 -0400
@@ -0,0 +1,73 @@
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+# Copyright 2015, Richard Lowe.
+
+
+include $(SRC)/cmd/Makefile.cmd
+include $(SRC)/test/Makefile.com
+
+PROG =	secflags_aslr		\
+	secflags_core		\
+	secflags_dts		\
+	secflags_elfdump	\
+	secflags_forbidnullmap	\
+	secflags_limits		\
+	secflags_noexecstack	\
+	secflags_proc		\
+	secflags_psecflags	\
+	secflags_syscall	\
+	secflags_truss		\
+	secflags_zonecfg
+
+PROG += addrs-32 addrs-64 stacky
+
+ROOTOPTPKG = $(ROOT)/opt/os-tests
+TESTDIR = $(ROOTOPTPKG)/tests/secflags
+
+CMDS = $(PROG:%=$(TESTDIR)/%)
+$(CMDS) := FILEMODE = 0555
+
+addrs-32: addrs.c
+	$(LINK.c) addrs.c -o $@ $(LDLIBS)
+	$(POST_PROCESS)
+
+addrs-64: addrs.c
+	$(LINK64.c) addrs.c -o $@ $(LDLIBS)
+	$(POST_PROCESS)
+
+stacky := MAPFILE.NES=			# Will foil the test, clearly
+stacky: stacky.o
+	$(LINK.c) -m32 stacky.o -o $@ $(LDLIBS)
+	$(POST_PROCESS)
+
+secflags_syscall: secflags_syscall.c
+	$(LINK.c) -m32 secflags_syscall.c -o $@ $(LDLIBS)
+	$(POST_PROCESS)
+
+all: $(PROG)
+
+install: all $(CMDS)
+
+lint: 
+
+clobber: clean
+	-$(RM) $(PROG)
+
+clean:
+
+$(CMDS): $(TESTDIR) $(PROG)
+
+$(TESTDIR):
+	$(INS.dir)
+
+$(TESTDIR)/%: %
+	$(INS.file)
--- /dev/null	2016-06-02 19:51:26.000000000 -0400
+++ new/usr/src/test/os-tests/tests/secflags/addrs.c	2016-06-02 19:51:26.163105196 -0400
@@ -0,0 +1,26 @@
+#include <sys/mman.h>
+
+#include <stdlib.h>
+#include <unistd.h>
+#include <err.h>
+
+int
+main(int argc, char **argv)
+{
+	int stack = 0;
+	void *heap = NULL;
+	void *mapping = NULL;
+
+	if ((heap = malloc(10)) == NULL)
+		err(1, "couldn't allocate");
+
+	if ((mapping = mmap((caddr_t)0, 10, (PROT_READ | PROT_WRITE),
+	    MAP_ANON|MAP_PRIVATE, -1, 0)) == (void*)-1)
+		err(1, "couldn't map");
+
+	printf("  stack: 0x%p\n", &stack);
+	printf("   heap: 0x%p\n", heap);
+	printf("mapping: 0x%p\n", mapping);
+	printf("   text: 0x%p\n", &main);
+	return (0);
+}
--- /dev/null	2016-06-02 19:51:26.000000000 -0400
+++ new/usr/src/test/os-tests/tests/secflags/secflags_aslr.sh	2016-06-02 19:51:26.547408773 -0400
@@ -0,0 +1,73 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+# Copyright 2015, Richald Lowe.
+
+# Verify that aslr musses things up, by comparing the mappings of 2 identical processes
+
+LC_ALL=C                        # Collation is important
+
+/usr/bin/psecflags -s aslr $$
+
+tmpdir=/tmp/test.$$
+
+mkdir $tmpdir
+cd $tmpdir
+
+cleanup() {
+    cd /
+    rm -fr $tmpdir
+}
+
+trap 'cleanup' EXIT
+
+check() {
+    typeset name=$1
+    typeset command=$2
+    
+    for (( i=0; i < 1000; i++ )); do
+        $command > out.$i
+    done
+
+    cat out.* | sort | uniq -c | sort -nk 1 | nawk '
+	BEGIN { 
+		tot = 0
+		colls = 0
+	}
+
+	$2 != "text:" {
+		tot += $1
+		if ($1 > 1) {
+			colls += $1
+		}
+	}
+
+	END {
+		prc = (colls / tot) * 100
+		printf "'$name' Collisions: %d/%d (%g%%)\n", colls, tot, prc
+		exit prc
+	}
+'
+    return $?
+}
+
+# Somewhat arbitrary
+ACCEPTABLE=70
+
+ret=0
+check 32bit /opt/os-tests/tests/secflags/addrs-32
+(( $? > $ACCEPTABLE )) && ret=1
+check 64bit /opt/os-tests/tests/secflags/addrs-64
+(( $? > $ACCEPTABLE )) && ret=1
+
+exit $ret
--- /dev/null	2016-06-02 19:51:26.000000000 -0400
+++ new/usr/src/test/os-tests/tests/secflags/secflags_core.sh	2016-06-02 19:51:26.933694569 -0400
@@ -0,0 +1,63 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright 2015, Richard Lowe.
+#
+
+mkdir /tmp/secflags-test.$$
+cd /tmp/secflags-test.$$
+
+/usr/bin/psecflags -s aslr -e sleep 100000 &
+pid=$!
+coreadm -p core $pid # We need to be able to reliably find the core
+
+cleanup() {
+    kill $pid >/dev/null 2>&1
+    cd /
+    rm -fr /tmp/secflags-test.$$
+}
+
+trap cleanup EXIT
+
+## gcore-produced core
+gcore $pid >/dev/null
+
+cat > gcore-expected.$$ <<EOF
+core 'core.$pid' of $pid:	sleep 100000
+	E:	aslr
+	I:	aslr
+EOF
+
+/usr/bin/psecflags core.${pid} | grep -v '[LU]:' > gcore-output.$$
+
+if ! diff -u gcore-expected.$$ gcore-output.$$; then
+    exit 1;
+fi
+
+## kernel-produced core
+kill -SEGV $pid
+
+cat > core-expected.$$ <<EOF
+core 'core' of $pid:	sleep 100000
+	E:	aslr
+	I:	aslr
+EOF
+
+/usr/bin/psecflags core | grep -v '[LU]:' > core-output.$$
+
+if ! diff -u core-expected.$$ core-output.$$; then
+    exit 1;
+fi
+
+exit 0
--- /dev/null	2016-06-02 19:51:27.000000000 -0400
+++ new/usr/src/test/os-tests/tests/secflags/secflags_dts.sh	2016-06-02 19:51:27.314463680 -0400
@@ -0,0 +1,71 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+# Copyright 2015, Richard Lowe.
+
+tmpdir=/tmp/test.$$
+mkdir $tmpdir
+cd $tmpdir
+
+cleanup() {
+    cd /
+    rm -fr $tmpdir
+}
+
+trap 'cleanup' EXIT
+
+cat > tester.c <<EOF
+#include <stdio.h>
+#include <unistd.h>
+
+int
+main(int argc, char **argv)
+{
+	sleep(10000);
+	return (0);
+}
+EOF
+
+gcc -o tester-aslr tester.c -Wl,-z,aslr=enabled
+gcc -o tester-noaslr tester.c -Wl,-z,aslr=disabled
+
+# This is the easiest way I've found to get many many DTs, but it's gross
+gcc -o many-dts-aslr tester.c -Wl,-z,aslr=enabled $(for elt in /usr/lib/lib*.so; do echo -Wl,-N,$(basename $elt); done)
+gcc -o many-dts-noaslr tester.c -Wl,-z,aslr=disabled $(for elt in /usr/lib/lib*.so; do echo -Wl,-N,$(basename $elt); done)
+
+check() {
+    bin=$1
+    state=$2
+    ret=0
+
+    $bin &
+    pid=$!
+    psecflags $pid | grep -q 'E:.*aslr'
+    (( $? != $state )) && ret=1
+    kill -9 $pid
+    return $ret
+}
+
+fail() {
+    echo $@
+    exit 1
+}
+
+psecflags -s none $$
+check ./tester-aslr 0 || fail "DT_SUNW_ASLR 1 failed"
+check ./many-dts-aslr 0 || fail "DT_SUNW_ASLR 1 with many DTs failed"
+
+psecflags -s aslr $$
+check ./tester-noaslr 1 || fail "DT_SUNW_ASLR 0 failed"
+check ./many-dts-noaslr 1 || fail "DT_SUNW_ASLR 0 with many DTs failed"
+
--- /dev/null	2016-06-02 19:51:27.000000000 -0400
+++ new/usr/src/test/os-tests/tests/secflags/secflags_elfdump.sh	2016-06-02 19:51:27.721095436 -0400
@@ -0,0 +1,79 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright 2015, Richard Lowe.
+#
+
+mkdir /tmp/secflags-test.$$
+cd /tmp/secflags-test.$$
+
+/usr/bin/psecflags -s aslr -e sleep 100000 &
+pid=$!
+coreadm -p core $pid # We need to be able to reliably find the core
+
+cleanup() {
+    kill $pid >/dev/null 2>&1
+    cd /
+    rm -fr /tmp/secflags-test.$$
+}
+
+trap cleanup EXIT
+
+## gcore-produced core
+gcore $pid >/dev/null
+
+cat > gcore-expected.$$ <<EOF
+    namesz: 0x5
+    descsz: 0x14
+    type:   [ NT_SECFLAGS ]
+    name:
+        CORE\0
+    desc: (prsecflags_t)
+        pr_version:    1
+        pr_effective:  [ ASLR ]
+        pr_inherit:    [ ASLR ]
+        pr_lower:      0
+        pr_upper:      [ ASLR FORBIDNULLMAP NOEXECSTACK ]
+EOF
+
+/usr/bin/elfdump -n core.${pid} | grep -B5 -A5 prsecflags_t > gcore-output.$$
+
+if ! diff -u gcore-expected.$$ gcore-output.$$; then
+    exit 1;
+fi
+
+## kernel-produced core
+kill -SEGV $pid
+
+cat > core-expected.$$ <<EOF
+    namesz: 0x5
+    descsz: 0x14
+    type:   [ NT_SECFLAGS ]
+    name:
+        CORE\0
+    desc: (prsecflags_t)
+        pr_version:    1
+        pr_effective:  [ ASLR ]
+        pr_inherit:    [ ASLR ]
+        pr_lower:      0
+        pr_upper:      [ ASLR FORBIDNULLMAP NOEXECSTACK ]
+EOF
+
+/usr/bin/elfdump -n core | grep -B5 -A5 prsecflags_t > core-output.$$
+
+if ! diff -u core-expected.$$ core-output.$$; then
+    exit 1;
+fi
+
+exit 0
--- /dev/null	2016-06-02 19:51:28.000000000 -0400
+++ new/usr/src/test/os-tests/tests/secflags/secflags_forbidnullmap.sh	2016-06-02 19:51:28.106755552 -0400
@@ -0,0 +1,25 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+# Copyright 2015, Richard Lowe.
+
+/usr/bin/psecflags -s forbidnullmap $$
+
+LD_PRELOAD=0@0.so.1 /usr/bin/sleep 100000 &
+pid=$!
+
+ret=0
+(pmap $pid | grep -q '^00000000 ') && ret=1
+kill -9 $pid
+
+exit $ret
--- /dev/null	2016-06-02 19:51:28.000000000 -0400
+++ new/usr/src/test/os-tests/tests/secflags/secflags_limits.sh	2016-06-02 19:51:28.487641816 -0400
@@ -0,0 +1,60 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright 2015, Richard Lowe.
+#
+
+mkdir /tmp/secflags-test.$$
+cd /tmp/secflags-test.$$
+
+cleanup() {
+    kill $pid >/dev/null 2>&1
+    cd /
+    rm -fr /tmp/secflags-test.$$
+}
+
+trap cleanup EXIT
+
+# Check that lower implies setting of inheritable
+echo "Setting lower also adds to inheritable" 
+/usr/bin/psecflags -s L=aslr $$
+
+cat > expected <<EOF
+	I:	aslr
+EOF
+/usr/bin/psecflags $$ | grep 'I:' > output
+
+diff -u expected output || exit 1
+
+echo "Setting in lower cannot be removed from inheritable"
+/usr/bin/psecflags -s I=current,-aslr $$ 2>/dev/null && exit 1
+
+echo "Setting in lower cannot be removed"
+/usr/bin/psecflags -s L=current,-aslr $$ 2>/dev/null && exit 1
+
+
+echo "Setting in lower cannot be removed from upper"
+/usr/bin/psecflags -s U=current,-aslr $$ 2>/devlnull && exit 1
+
+/usr/bin/psecflags -s U=current,-noexecstack $$
+
+echo "Setting in default cannot exceed upper"
+/usr/bin/psecflags -s I=noexecstack $$ 2>/dev/null && exit 1
+
+echo "Setting cannot ever be added to upper"
+/usr/bin/psecflags -s U=current,+noexecstack $$ 2>/dev/null && exit 1
+
+exit 0
+
+
--- /dev/null	2016-06-02 19:51:28.000000000 -0400
+++ new/usr/src/test/os-tests/tests/secflags/secflags_noexecstack.sh	2016-06-02 19:51:28.881038903 -0400
@@ -0,0 +1,25 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+# Copyright 2015, Richard Lowe.
+
+/usr/bin/psecflags -s noexecstack $$
+
+/opt/os-tests/tests/secflags/stacky &
+pid=$!
+
+ret=0
+(pmap $pid | grep -q 'rwx.*\[ stack \]$') && re=1
+
+kill -9 $pid
+exit $ret
--- /dev/null	2016-06-02 19:51:29.000000000 -0400
+++ new/usr/src/test/os-tests/tests/secflags/secflags_proc.sh	2016-06-02 19:51:29.265091568 -0400
@@ -0,0 +1,41 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright 2015, Richard Lowe.
+#
+
+/usr/bin/psecflags -s aslr -e sleep 100000 &
+pid=$!
+
+cleanup() {
+    kill $pid
+    rm /tmp/output.$$
+    rm /tmp/expected.$$
+}
+
+trap cleanup EXIT
+
+cat > /tmp/expected.$$ <<EOF
+$pid:	sleep 100000
+	E:	aslr
+	I:	aslr
+EOF
+
+/usr/bin/psecflags $pid | grep -v '[LU]:' > /tmp/output.$$
+
+if ! diff -u /tmp/expected.$$ /tmp/output.$$; then
+    exit 1;
+fi
+
+exit 0
--- /dev/null	2016-06-02 19:51:29.000000000 -0400
+++ new/usr/src/test/os-tests/tests/secflags/secflags_psecflags.sh	2016-06-02 19:51:29.656960465 -0400
@@ -0,0 +1,195 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright 2015, Richard Lowe.
+#
+
+mkdir /tmp/$$-secflags-test
+cd /tmp/$$-secflags-test
+
+/usr/bin/psecflags -s none $$   # Clear ourselves out
+cat > expected <<EOF
+	I:	none
+EOF
+
+/usr/bin/psecflags $$ | grep I: > output
+diff -u expected output || exit 1 # Make sure the setting of 'none' worked
+
+cleanup() {
+    cd /
+    rm -fr /tmp/$$-secflags-test
+}
+trap cleanup EXIT
+
+## Tests of manipulating a running process (ourselves)
+
+self_set() {
+    echo "Set (self)"
+    /usr/bin/psecflags -s aslr $$
+
+    cat > expected <<EOF
+	I:	aslr
+EOF
+
+    /usr/bin/psecflags $$ | grep I: > output
+    diff -u expected output || exit 1
+}
+
+self_add() {
+    echo "Add (self)"
+    /usr/bin/psecflags -s current,noexecstack $$
+    cat > expected <<EOF
+	I:	aslr, noexecstack
+EOF
+
+    /usr/bin/psecflags $$ | grep I: > output
+    diff -u expected output || exit 1
+}
+
+self_remove() {
+    echo "Remove (self)"
+    /usr/bin/psecflags -s current,-aslr $$
+    cat > expected <<EOF
+	I:	noexecstack
+EOF
+
+    /usr/bin/psecflags $$ | grep I: > output
+    diff -u expected output || exit 1
+}
+
+self_all() {
+    echo "All (self)"
+    /usr/bin/psecflags -s all $$
+    /usr/bin/psecflags $$ | grep -q 'I:.*,.*,' || exit 1 # This is lame, but functional
+}
+
+self_none() {
+    echo "None (self)"
+    /usr/bin/psecflags -s all $$
+    /usr/bin/psecflags -s none $$
+    cat > expected <<EOF
+	I:	none
+EOF
+    /usr/bin/psecflags $$ | grep I: > output
+    diff -u expected output || exit 1
+}
+
+child_set() {
+    echo "Set (child)"
+
+    typeset pid; 
+
+    /usr/bin/psecflags -s aslr -e sleep 10000 &
+    pid=$!
+    cat > expected <<EOF
+	E:	aslr
+	I:	aslr
+EOF
+    /usr/bin/psecflags $pid | grep '[IE]:' > output
+    kill $pid
+    diff -u expected output || exit 1
+}
+
+child_add() {
+    echo "Add (child)"
+
+    typeset pid; 
+
+    /usr/bin/psecflags -s aslr $$
+    /usr/bin/psecflags -s current,noexecstack -e sleep 10000 &
+    pid=$!
+    cat > expected <<EOF
+	E:	aslr, noexecstack
+	I:	aslr, noexecstack
+EOF
+    /usr/bin/psecflags $pid | grep '[IE]:' > output
+    kill $pid
+    /usr/bin/psecflags -s none $$
+    diff -u expected output || exit 1
+}
+
+child_remove() {
+    echo "Remove (child)"
+
+    typeset pid; 
+
+    /usr/bin/psecflags -s aslr $$
+    /usr/bin/psecflags -s current,-aslr -e sleep 10000 &
+    pid=$!
+    cat > expected <<EOF
+	E:	none
+	I:	none
+EOF
+    /usr/bin/psecflags $pid | grep '[IE]:' > output
+    kill $pid
+    /usr/bin/psecflags -s none $$
+    diff -u expected output || exit 1
+}
+
+child_all() {
+    echo "All (child)"
+
+    typeset pid ret
+
+    /usr/bin/psecflags -s all -e sleep 10000 &
+    pid=$!
+    /usr/bin/psecflags $pid | grep -q 'E:.*,.*,' # This is lame, but functional
+    ret=$?
+    kill $pid
+    (( $ret != 0 )) && exit $ret
+}
+
+child_none() {
+    echo "None (child)"
+
+    typeset pid
+    
+    /usr/bin/psecflags -s all $$
+
+    /usr/bin/psecflags -s none -e sleep 10000 &
+    pid=$!
+    cat > expected <<EOF
+	E:	none
+	I:	none
+EOF
+    /usr/bin/psecflags $pid | grep '[IE]:' > output
+    kill $pid
+    diff -u expected output || exit 1
+}
+
+list() {
+    echo "List"
+    cat > expected<<EOF
+aslr
+forbidnullmap
+noexecstack
+EOF
+
+    /usr/bin/psecflags -l > output
+    diff -u expected output || exit 1
+}
+
+self_set
+self_add
+self_remove
+self_all
+self_none
+child_set
+child_add
+child_remove
+child_all
+child_none
+list
+
+exit 0
--- /dev/null	2016-06-02 19:51:30.000000000 -0400
+++ new/usr/src/test/os-tests/tests/secflags/secflags_syscall.c	2016-06-02 19:51:30.044760081 -0400
@@ -0,0 +1,68 @@
+#include <stdio.h>
+#include <err.h>
+#include <errno.h>
+
+#include <sys/secflags.h>
+#include <sys/syscall.h>
+
+int
+main(int argc, char **argv)
+{
+	int err = 0;
+	secflagdelta_t act = {0};
+
+	if ((err = syscall(SYS_psecflags, NULL, PSF_INHERIT, NULL)) != 0) {
+		if (errno != EFAULT)
+			warnx("attempt to set secflags with a NULL procset "
+			    "set errno other than EFAULT (%d)", errno);
+	} else {
+		warnx("attempt to set secflags with a NULL procset succeeded");
+	}
+
+	if ((err = syscall(SYS_psecflags, (void*)0xdeadbeef,
+	    PSF_INHERIT, NULL)) != 0) {
+		if (errno != EFAULT)
+			warnx("attempt to set secflags with a bad procset "
+			    "set errno other than EFAULT (%d)", errno);
+	} else {
+		warnx("attempt to set secflags with a bad procset succeeded");
+	}
+
+
+	if ((err = psecflags(P_PID, P_MYID, PSF_INHERIT, NULL)) != 0) {
+		if (errno != EFAULT)
+			warnx("attempt to set secflags with a NULL "
+			    "delta set errno to other than EFAULT (%d)",
+			    errno);
+	} else {
+		warnx("attempt to set secflags with a NULL delta succeeded");
+	}
+
+	if ((err = psecflags(P_PID, P_MYID, PSF_INHERIT,
+	    (void*)0xdeadbeef)) != 0) {
+		if (errno != EFAULT)
+			warnx("attempt to set secflags with a bad "
+			    "delta set errno to other than EFAULT (%d)",
+			    errno);
+	} else {
+		warnx("attempt to set secflags with a bad delta succeeded");
+	}
+
+	if ((err = psecflags(P_LWPID, P_MYID, PSF_INHERIT, &act)) != 0) {
+		if (errno != EINVAL)
+			warnx("attempt to set secflags of an lwpid set errno "
+			    "to other than EINVAL (%d)", errno);
+	} else {
+		warnx("attempt to set secflags of an lwpid succeeded");
+	}
+
+	if ((err = psecflags(P_LWPID, P_MYID, PSF_EFFECTIVE, &act)) != 0) {
+		if (errno != EINVAL)
+			warnx("attempt to set effective secflags set errno "
+			    "to other than EINVAL (%d)", errno);
+	} else {
+		warnx("attempt to set effective secflags succeeded");
+	}
+
+	return (0);
+}
--- /dev/null	2016-06-02 19:51:30.000000000 -0400
+++ new/usr/src/test/os-tests/tests/secflags/secflags_truss.sh	2016-06-02 19:51:30.427367126 -0400
@@ -0,0 +1,43 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright 2015, Richard Lowe.
+#
+
+cd /tmp;
+
+cleanup() {
+    rm /tmp/output.$$
+    rm /tmp/expected.$$
+}
+
+trap cleanup EXIT
+
+cat > /tmp/expected.$$ <<EOF
+^psecflags\(0x[0-9A-F]+, PSF_INHERIT, \{ PROC_SEC_ASLR, 0x0, 0x0, B_FALSE \}\) = 0$
+EOF
+
+truss -t psecflags /usr/bin/psecflags -s current,aslr -e ls \
+      >/dev/null 2>output.$$
+
+if ! grep -qEf /tmp/expected.$$ /tmp/output.$$; then
+    echo "truss: failed"
+    echo "output:"
+    sed -e 's/^/  /' output.$$
+    echo "should match:"
+    sed -e 's/^/  /' expected.$$
+    exit 1;
+fi
+
+exit 0
